﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MoNo;
using MoNo.Graphics;

namespace GLViewportSample
{
  class SampleEntity
  {
    public Point3d P1 { get; } = new Point3d(1, 0, 0);
    public Point3d P2 { get; } = new Point3d(0, 1, 0);
    public Point3d P3 { get; } = new Point3d(0, 0, 1);
  }

  [System.ComponentModel.Composition.Export(typeof(MoNo.Graphics.ISceneFactory))]
  class SampleEntitySceneFactory : MoNo.Graphics.AbstractSceneFactory<SampleEntity>
  {
    protected override IScene Create( SampleEntity target, object[] args )
    {
      Console.WriteLine("SampleEntitySceneFacotry.Create()");
      var nrm = ((target.P2 - target.P1) * (target.P3 - target.P1)).Normalize();
      return GraphicsUT.CreateScene(
        MoNo.OpenGL.GLPrimType.Triangles,
        new[] { new PointNormal3d(nrm, target.P1), new PointNormal3d(nrm, target.P2), new PointNormal3d(nrm, target.P3) });
    }
  }
}
