﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel.Composition;
using MoNo;
using MoNo.Studio;
using MoNo.Geometries;
using MoNo.Wpf;
using MoNo.CSharpUtils;

namespace QuickCsTemplate
{
  [Export( typeof( MoNo.Studio.IContextMenuFactory ) )]
  class Tris3dMenuFactory : ContextMenuFactoryForCSharp<Soup<Triangle<Point3d>>>
  {
    public override IEnumerable<MenuItem> EnumerateMenuItems( Soup<Triangle<Point3d>> target, Entry entry, ApplicationContext con )
    {
      yield return
        con.CreateCommand( () =>
          con.Messenger.Send( new InformationMessage( string.Format( "count = {0}", target.Items.Length ), "facet count" ) )
        ).ToMenuItem( "facet count" );
    }
  }
}
