﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using MoNo;
using MoNo.CSharpUtils;

namespace StandardCsTemplate.ViewModels
{
  public class VmSampleDialog : MoNo.Wpf.IDialogModel
  {
    public bool DialogResult { get; private set; }

    public Reactive<string> InputText { get; private set; }
    public IReactive<string> UpperCaseText { get; private set; }

    public ICommand HelloCommand { get; private set; }

    public void OnOK() { this.DialogResult = true; }

    public VmSampleDialog(MoNo.Wpf.ApplicationContext con)
    {
      this.InputText = new Reactive<string>( "sample text" );
      this.UpperCaseText = this.InputText.Map( s => s.ToUpper() );
      this.HelloCommand = con.CreateCommand( () => con.ShowMessage( "Hello, Sample Dialog" ) );
    }
  }
}
