﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MoNo;

namespace StandardTemplate.Views
{
  /// <summary>
  /// MainWindow.xaml の相互作用ロジック
  /// </summary>
  public partial class MainWindow : Window
  {
    public MainWindow()
    {
      InitializeComponent();
    }

    protected override void OnSourceInitialized( EventArgs e )
    {
      base.OnSourceInitialized( e );
      MoNo.Studio.WindowPlacementModule.loadByDefaultPath( this );
    }

    protected override void OnClosing( System.ComponentModel.CancelEventArgs e )
    {
      base.OnClosing( e );
      this.DataContext.As<ViewModels.AppContext>( con => con.OnClosing( e ) );
      if ( !e.Cancel ) MoNo.Studio.WindowPlacementModule.saveByDefaultPath( this );
    }

    private void Window_Drop( object sender, DragEventArgs e )
    {
      var files = e.Data.GetData( DataFormats.FileDrop ) as string[];
      if ( files != null ) {
        base.DataContext.As<ViewModels.AppContext>( con => con.OnFileDrop( files ) );
      }
    }

    private void Window_PreviewDragOver( object sender, DragEventArgs e )
    {
      e.Effects = e.Data.GetDataPresent( DataFormats.FileDrop, true ) ? DragDropEffects.Copy : DragDropEffects.None;
    }
  }
}
