﻿namespace CommandSample
open MoNo

type Model () =
  let value = Reactive 0
  member __.Value = value
  member __.Increment () = value.Val <- value.Val + 1
  member __.Decrement () = value.Val <- value.Val - 1
  member __.Double    () = value.Val <- 2 * value.Val
  member val CanDecrement = value |> Reactive.map (fun x -> x >= 1)
  member val DivBy2Command =
    cont { value.Val <- value.Val / 2 }
    |> Command.ofCont
    |> Command.guardBy (value |> Reactive.map (fun x -> x >= 10))

